# -----------------------------------------------------------------------------
sub sqlTLog
# -----------------------------------------------------------------------------
{
  #----
  #---- This routine uses stacked data
  #----

  ($thishost) = @_;

  if ($t_arclog_w[$thishost] eq "N")
  {
    &logit("(Not Selected (T_Arclog_Full: is N)",$thishost);
    return 1;
  }

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  #---- 2011/01/02 BB - Was 95/99
  if ($t_arclog_w[$thishost] eq "") { $t_arclog_w[$thishost] = "80" }
  if ($t_arclog_c[$thishost] eq "") { $t_arclog_c[$thishost] = "90" }
  
  &logDetails($thishost,"</table>");
  &logDetails($thishost,"<br><a name='#sqlTLog'> <h3>MSSQL Transaction Log Status</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s DBName
    <th>$f_s TLog Size<br> (MB)
    <th>$f_s DB Size<br> (MB)
    <th>$f_s DB+TLog Size<br> (MB)
    <th>$f_s TLog Size to<br> DB Size<br> Ratio 
    <th>$f_s Trunc. On Ckpt.<br>(Simple Recovery Mode)
    <th>$f_s Growth<br>(Max)<br> Setting<br>(MB)
    <th>$f_s % Full vs. Growth Setting
    <th>$f_s % Full Internal<br> (DBCC SQLPERF (LOGSPACE))
    <th>$f_s Filename
    <th>$f_s Drive
    <th>$f_s Drive % Full 
  ");

  # print "$P TLOG: $dbname $trunc $size $pctused $this_drive_letter $this_drive_pctused $dbp_log_fname $dbp_log_space\n";
  # dbamon_mssql.pl TLOG: master                 Yes    1.24 48.86 E 80.56 E:\\MSSQL7\\data\\mastlog.ldf                            Unlimited
  # dbamon_mssql.pl TLOG: WSS_Content_Frontier_5 No  3149.31  0.82 L       L:\\MSSQL.1\\MSSQL\\Data\\WSS_Content_Frontier_5_log.LDF 2147483.65

  foreach (split('\n',$tlogdata[$thishost]))
  {
    @words = split;
    ##$tl_dbname   = lc $words[2];   Leave the case 2010/11/25
    $tl_dbname   = $words[2]; 
    $tl_trunc    = $words[3]; 
    $tl_tlsize   = $words[4]; 
    $tl_pctused  = $words[5]; 
    $tl_drive    = $words[6]; 
    $tl_drivepct = $words[7]; 
    $tl_filename = $words[8]; 
    $tl_growth   = $words[9]; 

    ##print "DEBUG1 - tl_dbname=$tl_dbname tl_growth=$tl_growth\n";

    #---- Derived vars 

    if ($tl_growth eq "Unlimited")
    {
      $this_tl_full_vs_limit = -1;
      #---- USER Event
      &event("U",$thishost,"DBName=$tl_dbname - TLog Is MAXSIZE=Unlimited","TLog-Unlimited","DBA200");
    }
    if ($tl_growth eq "FixedSize")
    {
      $this_tl_full_vs_limit = -1;
      #---- USER Event
      &event("W",$thishost,"DBName=$tl_dbname - TLog Is MAXSIZE=Fixed (No Growth)","TLog-FixedSize","DBA200");
    }
    elsif ($tl_growth == 0)
    {
      $this_tl_full_vs_limit = -2;
    }
    else
    {
      $this_tl_full_vs_limit = sprintf "%.2f",($tl_tlsize / $tl_growth) * 100;
    }

    #---- Try to get rid of the doubleslashes in the filenames
    $tl_filename =~ s/\\\\/\\/g;

    my $ztotsize = $db_info_tl_dbsize[$thishost]{$tl_dbname} + $tl_tlsize;
    my $zdbsize  = $db_info_tl_dbsize[$thishost]{$tl_dbname} ;
    my $zratio   = $db_info_tl_ratio[$thishost]{$tl_dbname} ;

    $z = "<tr> 
      <td>$f_s <b> $tl_dbname </b>
      <td align=right>$f_s $tl_tlsize
      <td align=right>$f_s $db_info_tl_dbsize[$thishost]{$tl_dbname}
      <td align=right>$f_s $ztotsize
      <td align=right>$f_s $db_info_tl_ratio[$thishost]{$tl_dbname} 
      <td>$f_s $tl_trunc
      <td>$f_s $tl_growth
      <td align=right>$f_s $this_tl_full_vs_limit
      <td align=right>$f_s $tl_pctused
      <td nowrap>$f_s <b> $tl_filename </b>
      <td>$f_s $tl_drive
      <td align=right>$f_s ${tl_drivepct}% ";
    &logDetails($thishost,$z);

    if ($debug_294 eq "Y")
    {
      print "$titleraw[$thishost] - tl_dbname=$tl_dbname tl_trunc=$tl_trunc tl_tlsize=$tl_tlsize tl_pctused=$tl_pctused tl_drive=$tl_drive\n";
      print "    tl_drivepct=$tl_drivepct tl_filename=$tl_filename tl_growth=$tl_growth\n";
      print "    this_tl_full_vs_limit=$this_tl_full_vs_limit\n";
    }

    &metricsInsert("sqlTLog()",$thishost,"TLOG_PCT_VS_MAX",$tl_dbname,$this_tl_full_vs_limit);
    &metricsInsert("sqlTLog()",$thishost,"TLOG_PCT_INT",$tl_dbname,$tl_pctused);

    #---- Prepare event file just in case
    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
    print TMPFL2 "DBName:                $tl_dbname\n";
    print TMPFL2 "Trunc_Log_On_Ckpt:     $tl_trunc\n";
    print TMPFL2 "TLog_Pct_Full:         $tl_pctused\n";
    print TMPFL2 "TLog_Size:             $tl_tlsize\n";
    print TMPFL2 "DBSize:                $zdbsize\n";
    print TMPFL2 "TLogSize_DBSize_Ratio: $zratio\n";
    print TMPFL2 "TLog_File_Path:        $tl_filename\n";
    print TMPFL2 "TLog_Drive:            $tl_drive\n";
    print TMPFL2 "TLog_Drive_Pct_Full:   $tl_drivepct\n";
    print TMPFL2 "TLog_Growth_Setting:   $tl_growth\n";
    print TMPFL2 "Warning_Threshold:     $t_arclog_w[$thishost]%\n";
    print TMPFL2 "Critial_Threshold:     $t_arclog_c[$thishost]%\n";
    close(TMPFL2);

    #---- Events 
    #---- (pidgin code)
    #
    # is tlog internal % full >= thresholds?
    # {
    #   is growth unlimited and disk is >= thresholds full?
    #   {
    #     event 658
    #   }
    #   elsif is growth limited and logs are >= threshold full vs. size limit
    #   {
    #     event 657
    #   }
    # }
    #  

    $event_tlog_flag = 0; 

    if ($tl_pctused >= $t_arclog_w[$thishost])
    {
      if ($tl_growth eq "Unlimited")
      {
	#---- Event #2 - Disk Full

        &metricsCurrent("sqlTLog()",$thishost,"TLOG_FULL_UNL_DRIVE",$tl_dbname,$tl_drivepct,$t_arclog_w[$thishost],$t_arclog_w[$thishost],
          "TLog for this DB ($tl_dbname) has at least 1 file with UNLIMITED growth - Therefore, we measure the fullness of drive $tl_drive") ;

	if ($tl_drivepct >= $t_arclog_w[$thishost])
	{
	  if ($tl_drivepct >= $t_arclog_c[$thishost])
	  {
	    $event_sev      = "C";
	    $event_sev_long = "Critical";
	    $event_pct      = $t_arclog_c[$thishost];
	  }
	  elsif ($tl_drivepct >= $t_arclog_w[$thishost])
	  {
	    $event_sev      = "W";
	    $event_sev_long = "Warning";
	    $event_pct      = $t_arclog_w[$thishost];
	  }

	  $event_text = "DB=$tl_dbname - TLog with UNLIMITED growth - Drive $tl_drive is $tl_drivepct full ($event_sev_long Threshold of $event_pct% exceeded - TLSize=$tl_tlsize(mB) TLPath=$tl_filename)";

	  &event("$event_sev",$thishost,$event_text,"TLogFull-${event_sev_long}-DiskFull","DBA658",$tmpfl2);
          $event_tlog_flag = 1; 
	}
      }
      else      #---- Not unlimited
      {
	#---- Event #1 - Size vs. Limit

        &metricsCurrent("sqlTLog()",$thishost,"TLOG_FULL_VS_MAX",$tl_dbname,$this_tl_full_vs_limit,$t_arclog_w[$thishost],$t_arclog_w[$thishost],
          "TLog for this DB ($tl_dbname) versus file total MAX size") ;

	if ($this_tl_full_vs_limit >= $t_arclog_w[$thishost] && $tl_pctused >= $t_arclog_w[$thishost] )
	{
	  if ($this_tl_full_vs_limit >= $t_arclog_c[$thishost] && $tl_pctused >= $t_arclog_c[$thishost])
	  {
	    $event_sev      = "C";
	    $event_sev_long = "Critical";
	    $event_pct      = $t_arclog_c[$thishost];
	  }
	  ##elsif ($this_tl_full_vs_limit >= $t_arclog_w[$thishost])
	  else 
	  {
	    $event_sev      = "W";
	    $event_sev_long = "Warning";
	    $event_pct      = $t_arclog_w[$thishost];
	  }

          $tl_pctused_int = int($tl_pctused); 
	  $this_tl_full_vs_limit_int = int($this_tl_full_vs_limit); 
	  $event_text = "DB=$tl_dbname - TLog with LIMITED size is ${this_tl_full_vs_limit_int}% full (vs. LIMIT) AND TLog is Internally ${tl_pctused_int}% Full ($event_sev_long Threshold of $event_pct% exceeded - TLSize=${tl_tlsize}(mB) TLLimit=${tl_growth}(mB))";
	
	  &event("$event_sev",$thishost,$event_text,"TLogFull-${event_sev_long}-Limit","DBA657",$tmpfl2);
          $event_tlog_flag = 1; 
	}
      }
    }

    if ($event_tlog_flag == 0)
    {
      &logit("OK - DB=($tl_dbname) - TLog_Pct_Full=$tl_pctused TLog_Size=$tl_tlsize DBSize=$zdbsize TLog-DBSize-Ratio=$zratio",$thishost); 
      &logit("  Simple_Recov=$tl_trunc TLog_Drive=$tl_drive TLog_Drive_Pct_Full=$tl_drivepct TLog_Growth_Setting=$tl_growth",$thishost);
    }
  }

  &logDetails($thishost,"</table><hr>");
}
# -----------------------------------------------------------------------------
1;
