#-----------------------------------------------------------------------------
sub sqlUp
#-----------------------------------------------------------------------------
{
  ($thishost) = @_;

  my $leak_records = 0; 

  #---- Get Instance online data
  ##I don't know why i did this???  up[$thishost] = ""

  $titlehist[$thishost] = "?" if !$titlehist[$thishost];
  $title1[$thishost]    = "?" if !$title1[$thishost];

  #---- BB 28Jul06 - Changed defaults from 95/99 to 90/95
  #---- BB 02Jan11 - Changed defaults from 90/95 to 80/90
  $t_diskwarn[$thishost] = "80" if !$t_diskwarn[$thishost];
  $t_diskcrit[$thishost] = "90" if !$t_diskcrit[$thishost];

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  #---- OLD, Obsolete
  if ($g_history_to_file eq "Y")
  {
    # Check to see if  we need to create history data
    chop($filedate = `date +%C%y.%m.%d`);
    chop($filetime = `date +%H:%M:%S`);
    $hist_flag = 0;
    if (system("grep '$titleraw[$thishost]' $hstdir/dbspaces/$filedate > /dev/null 2>&1") != 0)
    {
      &logit("Setting flag to create tblspace history data",$thishost);
      system("rm $tmpflt > /dev/null 2>&1");
      $hist_flag = 1;
    }
  }

  # Start with a clean slate
  $up[$thishost] = "";

  $must_connect = 1;
  &remsh("$perlpath[$thishost] $probe[$thishost] up . $probe_parm[$thishost]",$tmpfl3,$thishost);
  &probeLog; 

  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error)",$thishost);
    return;
  }

  my $db_good_owner = "SA";
  my $db_owner_fix;
  my $db_owner_rollback;
  my $db_owner_counter = 0;

  my $dbstatus = "";
  my $agentstatus = "";
  my $total_size = "";
  my $total_used = "";

  my $oldperl_kill = ""; 
  my $oldperl_details = ""; 
  my $oldperl_maxage = ""; 
  my $oldperl_pids = ""; 
  my $oldperl_cnt = 0; 

  $badparms[$thishost] = "";
  $dbcount[$thishost] = "";
  $udbcount[$thishost] = 0;
  undef $tlogdata[$thishost];
  undef $drivedata[$thishost];
  undef $drivegrowthdata[$thishost];
  undef $fgdata[$thishost];
  undef $diskdrivedata; 

  $rmt_hostname[$thishost] = ""; 
  $os64bit[$thishost] = ""; 
  $mssql64bit[$thishost] = ""; 

  undef $lrbackup_age_hrs[$thishost]; 
  undef $lrbackup_message[$thishost]; 
  undef $sqljob_data[$thishost]; 

  undef $cluster_name[$thishost]; 
  undef $cluster_status[$thishost]; 
  undef $cluster_onnode[$thishost]; 
  undef $cluster_thisnodestatus[$thishost]; 
  undef $save_config[$thishost];  
  undef %dbsize; 

  &logDetails($thishost,"<br><a name='#sqlUpDBS'> <h3>MSSQL Databases</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Database<br>Name
    <th>$f_s Space<br>Used*<br>DB + TLog<br>(MB)
    <th>$f_s Space<br>Allocated<br>DB + TLog<br>(MB)
    <th>$f_s Database<br>Owner
    <th>$f_s Date<br>Last<br>Object Created
    <th>$f_s DB Attributes (2005+ Only)</tr>");

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;

    #---- Eliminate records that we don'ty care about
    next if $F1 =~ /^2/ && length($F1) == 19; 

    if ($F1 eq "SQLVer:")      
    { 
      $z = $F2;

      # convert from x.xx.xxx format for x.xx.xxxx
      $z =~ tr/\(/./;
      $z =~ tr/\)//d;
      @words = split(/\./,$z);
      if (length($words[2]) == 3)
      {
	$z =~ s/$words[2]/0$words[2]/g;
      }
      #---- Since we now are in version 10.x, we need to pad earlier versions with zero 
      #----  so that it will sort correctly
      if (length($words[0]) == 1)
      {
	$z = "0" . $z;
      }

      $sw_version[$thishost] = $z;
      next;
    }

    if ($F2 eq "PERF:")    
    {
      $zkey = "SQL_" . $F3; 
      $perf_readings[$thishost]{$zkey} = $F4;
      next;
    }

    #---- dbamon_mssql.pl Stack: SaveConfig:
    if ($F2 eq "Stack:" && $F3 eq "SaveConfig:")    
    {
      $save_config[$thishost] .= $F0; 
      ##print "F0=$F0\n"; 
      next;
    }

    #---- $P SUSPECT_ROWCNT: $suspect_rowcnt
    if ($F2 eq "SUSPECT_ROWCNT:")    
    {
      &event("C",$thishost,"SUSPECT ROWS Found ($F3 rows) which indicated DB Corruption (SUSPECT_PAGES) - Investigate immediately","SuspectRows","DBA856");
      next;
    }

    #---- Long running BACKUPs - In this order
    #-----  dbamon_mssql.pl LRBACKUP_AGE_DET: (No backups running)
    #-----  dbamon_mssql.pl LRBACKUP_AGE_HRS: -1
    #-----  undef $lrbackup_age_hrs[$thishost]; 
    #-----  undef $lrbackup_message[$thishost]; 
    if ($F2 eq "LRBACKUP_AGE_DET:")    
    {
      $lrbackup_message[$thishost] = substr($F0,34); 
      next;
    }

    #---- dbamon_mssql.pl DBDFCount: tempdb 2
    if ($F2 eq "DBDFCount:")    
    {
      if (lc $F3 eq "tempdb") { $mssql_tempdb_dfcount[$thishost] = $F4; }
      next;
    }

    #---- dbamon_mssql.pl SIGNAL_Wait_Pct: 1.55 
    if ($F2 eq "SIGNAL_Wait_Pct:")    
    {
      $mssql_perf_signal_wait_pct[$thishost] = $F3; 
      next;
    }

    if ($F2 eq "LRBACKUP_AGE_HRS:")    
    {
      $lrbackup_age_hrs[$thishost] = $F3; 
      $lrbackup_age_hrs[$thishost] = 0 if $lrbackup_age_hrs[$thishost] eq "";
      if ($t_lrbackup_age_hrs[$thishost] > 0 && $lrbackup_age_hrs[$thishost] >= $t_lrbackup_age_hrs[$thishost])
      {
        &event("C",$thishost,"Longest Running DB Backup Has Been Running for $lrbackup_age_hrs[$thishost] hour(s) (>= Threshold: $t_lrbackup_age_hrs[$thishost] hours) - Process Details: $lrbackup_message[$thishost]","LongRunningDBBackup","DBA854");
      }
      #---- Record current and historical reading of this metric
      &metricsInsert ("sqlUp()",$thishost,"BACKUP_RUNNING_AGE_HRS",".",$lrbackup_age_hrs[$thishost]); 
      &metricsCurrent("sqlUp()",$thishost,"BACKUP_RUNNING_AGE_HRS","" ,$lrbackup_age_hrs[$thishost] ,"" ,$t_lrbackup_age_hrs[$thishost] ,"Max Backup Process Age (Hours) or NULL if no backup is running."); 
      next;
    }

    #---- SYSPERF data
    if ($F2 eq "SYSPERF:")    
    {
      if ($F3 =~ /^SQL/) { $zkey = $F3; }
      else               { $zkey = "SYS_" . $F3; }
      $perf_readings[$thishost]{$zkey} = $F4;
      next;
    }

    #---- DBMAIL status 
    if ($F2 eq "DBMAIL_STATUS:")    
    {
      $dbmail_status[$thishost] = "$F3 $F4 $F5";
      if ($F3 !~ /^OK/) 
      { 
        &event("C",$thishost,"DBMail Status NG - Most Recent DBMail Log Entry Should be SENT - Status: $dbmail_status[$thishost]","DBMail_NG","DBA853");
      }
      next;
    }

    #---- dbamon_mssql.pl VLF_COUNT: dbamon 196
    if ($F2 eq "VLF_COUNT:")
    {
      $glob_vlf_data[$thishost] .= "$F3 $F4\n"; 
      next; 
    }

    #---- BADPARMS Logic: 
    #---- dbamon_mssql.pl BADPARMS: bbtest3[BLANK]bdprms ISAUTOSHRINK=1,ISAUTOSHRINK=1
    if ($F2 eq "BADPARMS:")    
    {
      &event("P",$thishost,"Poorly Performing DB Parms Specified = DB=$F3 Parm(s)=($F4)","BadDBParms","DBA855");
      $badparms[$thishost] = $F4; 
      next;
    }

    if ($F2 eq "DRIVESTATUS:")    
    {
      #---- dbamon_mssql.pl DRIVESTATUS: E 52094 43768 8326 84.02
      $drivedata[$thishost] .= $F0;
      $dr_drive = (split(/ /,$F0)) [2];
      $dr_size  = (split(/ /,$F0)) [3];
      $dr_used  = (split(/ /,$F0)) [4];
      $dr_free  = (split(/ /,$F0)) [5];
      $dr_pct   = (split(/ /,$F0)) [6];

      my $dr_pct_int = int($dr_pct); 

      ##print "DRIVESTATUS $titleraw[$thishost] $F0" if $dr_pct >= 90;

      $color = "lightblue";

      &metricsCurrent("sqlUp()",$thishost,"DRIVE_PCT_FULL",$dr_drive,$dr_pct,$t_diskwarn[$thishost],$t_diskcrit[$thishost],"Drives that contain SQL Data") unless $t_diskwarn[$thishost] eq "N"; 

      open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
      print TMPFL2 "Drive:         $dr_drive\n";
      print TMPFL2 "Drive Size:    $dr_size (mb)\n";
      print TMPFL2 "Space Used:    $dr_used (mb)\n";
      print TMPFL2 "Space Free:    $dr_free (mb)\n";
      print TMPFL2 "Percent Full:  ${dr_pct}%\n";
      close(TMPFL2);

      if ($t_diskwarn[$thishost] && $t_diskwarn[$thishost] ne "N")
      {
        if ($dr_pct >= $t_diskcrit[$thishost])
        {
          &event("C",$thishost,"Drive $dr_drive is ${dr_pct_int} percent full (Critical threshold: $t_diskcrit[$thishost] percent)","DriveFullC","DBA805",$tmpfl2);
          $color = "pink";
          $zdrivestatus = "Critical"; 
        }
        elsif ($dr_pct >= $t_diskwarn[$thishost])
        {
          &event("W",$thishost,"Drive $dr_drive is ${dr_pct_int} percent full (Warning threshold: $t_diskwarn[$thishost] percent)","DriveFullW","DBA805",$tmpfl2);
          $color = "yellow";
          $zdrivestatus = "Warning"; 
        }
        else
        {
          $color = "lime";
          $zdrivestatus = "OK"; 
        }
      }

      $diskdrivedata .= "
      <tr bgcolor=$color>
        <td>$f_s <b> $dr_drive </b>
        <td align=right>$f_s $dr_size
        <td align=right>$f_s $dr_used
        <td align=right>$f_s $dr_free
        <td align=right>$f_s <b> ${dr_pct}% </b>
        <td align=right>$f_s ${t_diskwarn[$thishost]}%
        <td align=right>$f_s ${t_diskcrit[$thishost]}%
        <td align=right>$f_s <b> $zdrivestatus </b>
      ";

      &metricsInsert("sqlUp()",$thishost,"DRIVE_PCT_FULL",$dr_drive,$dr_pct);
      next;
    }

    if ($F2 eq "TLOG:")    
    {
      $tlogdata[$thishost] .= $F0;
      ##print "TLOG F0=$F0\n";
      next; 
    }

    if ($F2 eq "FG_ITEM:")    
    {
      $fgdata[$thishost] .= $F0;
      ##print "FG_ITEM Found - F0=$F0\n";
      next;
    }

    if ($F2 eq "FG_DRIVE_GROWTH:")    
    {
      $drivegrowthdata[$thishost] .= $F0;
      ##print "FG_ITEM Found - F0=$F0\n";
      next;
    }

    if ($F2 eq "OS64BIT:" && $F3 == 1)    
    {
      $os64bit[$thishost] .= "(64bit)";
      next;
    }

    if ($F2 eq "MSSQL64BIT:" && $F3 == 1)    
    {
      $mssql64bit[$thishost] .= "(64bit)";
      next;
    }

    if ($F2 eq "MEM_PCT:")    
    {
      $mem_pct[$thishost] = $F3; 
      next;
    }
    if ($F2 eq "MEM_AVAIL:")  
    { 
      $mem_avail[$thishost] = $F3; 
      next;
    }
    if ($F2 eq "MEM_USED:")   
    { 
      $mem_used[$thishost] = $F3; 
      next;
    }
    if ($F2 eq "RAM:")        
    { 
      $ram[$thishost] = $F3; 
      next;
    }

    if ($F2 eq "CPU_BUSY_WITH_SQL:")   
    { 
      $cpu_busy_with_sql[$thishost] = $F3; 
      next;
    }

    if ($F2 eq "SQL_Details:")  #---- New 2011/02/06
    {
      $mssql_version[$thishost]     = $F3;
      $mssql_patchlevel[$thishost]  = $F4;
      $mssql_edition[$thishost]     = $F5;
      $mssql_licensetype[$thishost] = $F6;
      $mssql_numlicenses[$thishost] = $F7;

      #---- This shows the actual version of SQL better than SQLVer: - So if it is non-null, replace sw_version
      $sw_version[$thishost] = $mssql_version[$thishost] if $mssql_version[$thishost];

      #---- For proper sorting, insert a zero for older versions of SQL      
      my $zfirstnum = (split(/\./,$sw_version[$thishost])) [0]; 
      if (length($zfirstnum) == 1)
      {
        $sw_version[$thishost] = "0" . $sw_version[$thishost]; 
      }
      next;
    }

    if ($F2 eq "UPTIME:")  #---- New
    {
      $str_c = $F3;
      $str_n = $F4;
      $end_c = $F5;
      $end_n = $F6;
      &uptimeLog($thishost);

   
      $mssql_started = $str_c;
      $mssql_seconds_up = $end_n - $str_n;
      $mssql_upfor_hours = sprintf("%.2f",($mssql_seconds_up / (60*60)));
      $mssql_upfor_days  = sprintf("%.2f",($mssql_seconds_up / (60*60*24)));
      ##print "str_c=$str_c end_c=$end_c str_n=$str_n end_n=$end_n mssql_second_up=$mssql_seconds_up mssql_upfor_hours=$mssql_upfor_hours\n"; 
      next;
    }

    if ($F2 eq "OLDPERL:")    
    {
      $oldperl_details .= substr($F0,25); 
      $z = substr($F6,6); 
      $oldperl_maxage = $z if $z > $oldperl_maxage;
      $oldperl_cnt++;
      $zpid = substr($F3,4); 
      $oldperl_kill .= "<b>C:\\dbatools\\pskill $zpid</b>\n"; 
      $oldperl_pids .= "$zpid "; 
      next;
    }

    # print "DoubleTakeStatus: $doubletake_status\n";
    # print "DoubleTakeDir: $doubletake_dir\n";
    # print "DoubleTakeFile: $doubletake_file\n";
    # print "DoubleTakeFileAgeMins: $doubletake_fileage_mins\n";
    if ($F1 eq "DoubleTakeStatus:")      {  $doubletake_status[$thishost] = $F2; next; }
    if ($F1 eq "DoubleTakeDir:")         {  $doubletake_dir[$thishost] = $F2; next; }
    if ($F1 eq "DoubleTakeFile:")        {  $doubletake_file[$thishost] = $F2; next; }
    if ($F1 eq "DoubleTakeFileAgeMins:") {  $doubletake_fileage_mins[$thishost] = $F2; next; }

    # dbamon_mssql.pl CLUSTERNAME: LSCASQLTEST
    # dbamon_mssql.pl CLUSTERSTATUS: Online
    # dbamon_mssql.pl CLUSTERONNODE: WCOSDBT1
    # dbamon_mssql.pl CLUSTERTHISNODESTATUS: Passive
    if ($F2 eq "CLUSTERNAME:")           {  $cluster_name[$thishost] = $F3; next; }
    if ($F2 eq "CLUSTERSTATUS:")         {  $cluster_status[$thishost] = $F3; next; }
    if ($F2 eq "CLUSTERONNODE:")         {  $cluster_onnode[$thishost] = $F3; next; }
    if ($F2 eq "CLUSTERTHISNODESTATUS:") {  $cluster_thisnodestatus[$thishost] = $F3; next; }

    #---- Save DB attributes
    if ($F2 eq "DB_ATTRS:")    
    {  
      $zdb = $F3;
      $db_attrs[$thishost]{$zdb} = $F4; 
      ##print "db_attrs=$db_attrs[$thishost]{$F3} F3=$F3\n";
      next;
    }

    if ($F2 eq "NET_IP:")      {  $net_ip[$thishost] = $F3 ; next; }
    if ($F2 eq "NET_VLAN:")    {  $net_vlan[$thishost] = $F3 ; next; }
    if ($F2 eq "NET_COMPANY:") {  $net_company[$thishost] = $F3 ; next; }

    if ($F1 eq "OSVer:")       {  $os_version[$thishost] = "$F2 $F3"; next; }
    if ($F1 eq "DBStatus:")    {  $dbstatus = $F2; next; }
    if ($F1 eq "AgentStatus:") {  $agentstatus = $F2; next; }
    if ($F1 eq "NumCPUs:")     {  $hw_processors[$thishost] = $F2; next; }
    if ($F1 eq "CPUModel:")    {  $hw_model[$thishost] = $F2; next; }
    if ($F1 eq "RAM:")         {  $hw_memory[$thishost] = $F2; next; }
    if ($F1 eq "SpaceAlloc:")  {  $total_size = $F2; next; }
    if ($F1 eq "SpaceUsed:")   {  $total_used = $F2; next; }
    if ($F1 eq "MSSQLServiceStatus:")   { $servicestatus = $F2; next; }
    if ($F1 eq "HOSTNAME:")    {  $rmt_hostname[$thishost] = $F2; next; }
    if ($F1 eq "RSHService:")  {  $rsh_service[$thishost] = $F2; next; }
    if ($F1 eq "ServerType:")  {  $server_type[$thishost] = $F2; next; }
    if ($F1 eq "DB:")
    {
      $this_db = $F2;
      $this_db_owner = uc $F7; 

      #---- Debug field mismatch problem for tempdb - 20110921
      #print "$titleraw[$thishost] - F0=$F0\n" if $F0 =~ /tempdb/i; 

      if ($F3 eq "CONNECTERROR")
      {
        &event("C",$thishost,"MSSQL Active But DB $F2 Is OFFLINE","MSSQLDBOff","DBA804C",$tmpfl3);
      }
      else
      #---- Create LOG entry for thsi DB
      {
	$zF3 = sprintf "%9.2f",$F3;
	$zF4 = sprintf "%9.2f",$F4;
	&logDetails($thishost,"<tr>
          <td>$f_s <b> $F2 </b> 
          <td align=right>$f_s $zF4 
          <td align=right>$f_s $zF3
          <td >$f_s $this_db_owner
          <td >$f_s $F5:$F6");

        #---- Log DB atrributes (if any)
        ##print "db_attrs=$db_attrs[$thishost]{$F2} F2=$F2\n";
        if ( $db_attrs[$thishost]{$F2} )
        {
	  &logDetails($thishost,"<td>$f_s $db_attrs[$thishost]{$this_db}");
        }

        #---- Current metric entry
        &metricsCurrent("sqlUp()",$thishost,"DB_RUNNING",$F2,-1,"","","DB Attributes: $db_attrs[$thishost]{$this_db}"); 

        #---- DB Owner processing
	$this_db_owner =~ s/\\\\/\\/;
	if ($this_db_owner eq $db_good_owner)
	{
	  ##$c_owner = "lime";
	}
        #---- 2011/12/20 BB: New
	elsif (index(uc $mssql_db_ok_owners[$thishost],uc $this_db_owner) > -1)
	{
	  ##$c_owner = "lime";
	}
	else
	{
	  ##$c_owner = "pink";
	  $db_owner_counter++;
          my $this_db_fix = $this_db;
          $this_db_fix =~ s'\[BLANK\]' 'g;
          $this_db_fix =~ s'\[HYPHEN\]'-'g;
	  $db_owner_fix      .= "-- $db_owner_counter. Change - DB [$this_db_fix] ($this_db) Owner from $this_db_owner to $db_good_owner
    USE [$this_db_fix]
    GO
    EXEC sp_changedbowner '$db_good_owner'
    GO\n";
	  $db_owner_rollback .= "-- $db_owner_counter. Rollback - DB [$this_db_fix] ($this_db) Owner from $db_good_owner to $this_db_owner
    -- USE [$this_db_fix]
    -- GO
    -- EXEC sp_changedbowner '$this_db_owner'
    -- GO\n";
	}

	if ($g_history_to_file eq "Y")
	{
	  if ($hist_flag)
	  {
	    system("echo '$filedate $filetime $title[$thishost] $F2 . $F3 $F4 $dbms[$thishost]' >> $tmpflt");
	  }
        }

	# Create repository history data
	&histCreate("sqlUp()",$thishost,"SPC",$F2,$zF3,$zF4);

        #---- Metrics
	&metricsInsert("sqlUp()",$thishost,"SPC_DB_ALLOC",$F2,$zF3);
	&metricsInsert("sqlUp()",$thishost,"SPC_DB_USED" ,$F2,$zF4);

        #---- Save this for later
        $dbsize{$F2} = $F3;

        # Increment db counter
        $dbtot_mssql++;
        $gbtot_mssql += ($F3 / 1000);

        $dbcount[$thishost]++;
        if ($this_db ne "master" && 
            $this_db ne "model"  && 
            $this_db ne "msdb"   && 
            $this_db ne "CICentral"   && 
            $this_db ne "tempdb")
        {
          $udbcount[$thishost]++;
        }

        $dblist[$thishost] .= $F2 . "\n";
      }
      next;   #---- DB:
    }

    if ($F0 =~ /^DDP:/ && $F0 =~ /JOBS:/)
    {
      $sqljob_data[$thishost] .= $F0;
      next; 
    }

    #---- We really should never get here
    $leak_records++; 
    ##print "DEBUG_SQLUP: $F0";

  }
  close(TMPFL3);
  ##print "DEBUG_SQLUP: leak_records=$leak_records\n";

  $ztotal_size = sprintf "%9.2f",$total_size;
  $ztotal_used = sprintf "%9.2f",$total_used;
  ##print "$ztotal_size $ztotal_used \n";
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s <b> Total </b> ($dbcount[$thishost] DBs):
    <th align=right>$f_s $ztotal_size
    <th align=right>$f_s $ztotal_used
    <th align=right>$f_s $mrdate
    <th>$f_s &nbsp; 
  </tr>");
  &logDetails($thishost,"</table>");
  &logDetails($thishost,"<br> &nbsp; *<b>Space Used</b> values are gathered from SP_SPACEUSED, which can be inaccurate. Run <b>SP_SPACEUSED \@UPDATEUSAGE='TRUE'</b> to correct.<p><hr>");

  if ($sw_version[$thishost] lt $ver_mssql_low  || $ver_mssql_low eq "" ) { $ver_mssql_low  = $sw_version[$thishost] }
  if ($sw_version[$thishost] gt $ver_mssql_high || $ver_mssql_high eq "") { $ver_mssql_high = $sw_version[$thishost] }

  $system_size[$thishost] = $total_size / 1000;  
  $system_used[$thishost] = $total_used / 1000;  
  ##print "su=$system_used[$thishost] $title[$thishost] \n";
  $grand_total_size += ($total_size / 1000);  

  # Check status
  if ($servicestatus eq "[Running]")
  {
    $dbmsg = "MSSQL Service IS Running";
  }
  else
  {
    $dbmsg = "MSSQL Service Is NOT Running";
  }
  if ($dbstats eq "")
  {
    $dbmsg .= ",Cannot Run SQL";
  }

  if ($dbstatus ne "UP")
  {
    $up[$thishost] = "N";
    &history_dummy($thishost);
    $hist_flag = 0;

    if ($t_mustbeup[$thishost] eq "Y")
    {
      &event("C",$thishost,"MSSQL Not Active: $dbstatus $dbmsg","MSSQLDown","DBA801",$tmpfl3) unless $cluster_thisnodestatus[$thishost] eq "Passive";
    }
    else
    {
      &event("I",$thishost,"MSSQL Not Active: $dbstatus $dbmsg","MSSQLDown","DBA801",$tmpfl3);
    }
  }
  else
  {
    $up[$thishost] = "Y";

    logit("OK",$thishost);
    if ($agentstatus ne "UP" && $mssql_agentmon[$thishost] ne "N" && $mssql_edition[$thishost] !~ /express/i)
    {
      &event("C",$thishost,"MSSQL Agent Service Not Active","AgentDown","DBA803C",$tmpfl3) unless $cluster_thisnodestatus[$thishost] eq "Passive";
    }
    &metricsCurrent("sqlUp()",$thishost,"AGENT_STATUS",'',-1,'','',"Status=$agentstatus"); 
  }

  if ($os_mode[$thishost] eq "") 
  { 
    if    ($hw_model[$thishost] =~ /64/) { $os_mode[$thishost] = '64'; }
    elsif ($hw_model[$thishost] =~ /86/) { $os_mode[$thishost] = '32'; }
    else                                 { $os_mode[$thishost] = ''; }
  }

  if (! $hw_processors[$thishost]) { $hw_processors[$thishost] = 1; }

  &logDetails($thishost,"<br><a name='#sqlUpSERVER'> <h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Type:<td align=right>$f_s $os[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Version:<td align=right>$f_s $os_version[$thishost] $os64bit[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>OS Mode:<td align=right>$f_s $os_mode[$thishost]<td>$f_s (32, 64 or Blank)");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Type:<td align=right>$f_s $hw_model[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Memory Total (MB):<td align=right>$f_s $hw_memory[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Memory Available(MB):<td align=right>$f_s $mem_avail[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Memory % Used:<td align=right>$f_s ${mem_pct[$thishost]}%");
  &logDetails($thishost,"<tr><td>$f_s <b>Server Processor Count:<td align=right>$f_s $hw_processors[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>NET IP Address:<td align=right>$f_s $net_ip[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>NET VLAN:<td align=right>$f_s $net_vlan[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>NET Company:<td align=right>$f_s $net_company[$thishost]");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<br><a name='#sqlUpINSTANCE'> <h3>MSSQL Instance Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL Version:<td align=right>$f_s $sw_version[$thishost] $mssql64bit[$thishost]");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL PatchLevel: <td align=right>$f_s $mssql_patchlevel[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL Up?<td align=right>$f_s $up[$thishost]<td>$f_s (Y or N)");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL Started:<td align=right>$f_s $mssql_started <td>$f_s ");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL Up For:<td align=right>$f_s $mssql_upfor_hours <td>$f_s (Hours)");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL Up For:<td align=right>$f_s $mssql_upfor_days  <td>$f_s (Days)");
  &logDetails($thishost,"<tr><td><b>$f_s Total DB Count:<td align=right>$f_s $dbcount[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr><td><b>$f_s Non-System DB Count:<td align=right>$f_s $udbcount[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL Software Edition: <td align=right>$f_s $mssql_edition[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL License Type: <td align=right>$f_s $mssql_licensetype[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr><td><b>$f_s MSSQL License Count: <td align=right>$f_s $mssql_numlicenses[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr><td><b>$f_s DBMail Status: <td align=right>$f_s $dbmail_status[$thishost]  <td>$f_s ");
  &logDetails($thishost,"<tr><td><b>$f_s Longest Currently Running DB Backup: <td align=right>$f_s $lrbackup_age_hrs[$thishost] (Hours) <td>$f_s $lrbackup_message[$thishost] ");
  &logDetails($thishost,"<tr><td><b>$f_s Bad DB Parms Found (If Any): <td>$f_s $badparms[$thishost] <td>$f_s ");
  &logDetails($thishost,"<tr><td><b>$f_s TEMPDB Database File Count: <td align=right>$f_s $mssql_tempdb_dfcount[$thishost] <td>$f_s ");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>CMDB Data (If Any)</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>CMDB Contacts:<td>$f_s $star_contacts[$thishost] ");
  &logDetails($thishost,"</table><hr>");

  if ($cluster_name[$thishost]) 
  {
    &logDetails($thishost,"<h3>Cluster Data</h3>");
    &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
    &logDetails($thishost,"<tr><td>$f_s <b>Cluster Name:<td>$f_s $cluster_name[$thishost] ");
    &logDetails($thishost,"<tr><td>$f_s <b>Cluster Global Status:<td>$f_s $cluster_status[$thishost] ");
    &logDetails($thishost,"<tr><td>$f_s <b>Cluster On Node:<td>$f_s $cluster_onnode[$thishost] ");
    &logDetails($thishost,"<tr><td>$f_s <b>Cluster This-Node Status:<td>$f_s $cluster_thisnodestatus[$thishost] ");
    &logDetails($thishost,"</table><hr>");
  }

  if ($doubletake_status[$thishost]) 
  {
    &logDetails($thishost,"<h3>DoubleTake Data</h3>");
    &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
    &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
    &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake Status:<td>$f_s $doubletake_status[$thishost] ");
    &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake Dir:<td>$f_s $doubletake_dir[$thishost] ");
    &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake File:<td>$f_s $doubletake_file[$thishost] ");
    &logDetails($thishost,"<tr><td>$f_s <b>DoubleTake File Age Mins:<td>$f_s $doubletake_fileage_mins[$thishost] ");
    &logDetails($thishost,"</table><hr>");
  }

  &logDetails($thishost,"<br><a name='#sqlUpDRIVE'> <h3>Disk Drive Data (Disks Which Contain MSSQL Database or TLog Files Belonging To This MSSQL Instance)</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  ##&logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Drive <th>$f_s Size (mB)<th>$f_s Used (mB)<th>$f_s Free (mB)<th>$f_s Percent Full</tr>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Drive 
    <th>$f_s Size (gB)
    <th>$f_s Used (gB)
    <th>$f_s Free (gB)
    <th>$f_s Percent <br> Full
    <th>$f_s Warning <br>Threshold 
    <th>$f_s Critical <br> Threshold 
    <th>$f_s Current <br> Status 
  </tr>");
  &logDetails($thishost,$diskdrivedata);
  &logDetails($thishost,"</table><hr>");

  if ($hist_flag)
  {
    &logit("Creating tablespace history data in ${hstdir}/dbspaces/${filedate}",$thishost);
    system("sort $tmpflt >> ${hstdir}/dbspaces/${filedate} ");
  }

  if ($oldperl_cnt > 0)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- Report of Old Perl Processes Which Should Be Killed:\n";
    print TMPFL2 "$oldperl_details";
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- DOS Commands to Kill These Processes:\n";
    print TMPFL2 "$oldperl_kill";
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- List of PIDs to Kill:\n";
    print TMPFL2 "$oldperl_pids";
    print TMPFL2 "$dashes\n";
    ##print TMPFL2 `cat $tmpfl3`;
    close(TMPFL2);
    &event("C",$thishost,"$oldperl_cnt Old Perl process(es) found - Max process age: $oldperl_maxage hours - Threshold: 12 hours","PerlOldProc","DBA802",$tmpfl2);
  }

  # Read SWVer data

  ##print "#swver_data=$#swver_data\n\n";
  ##foreach (@swver_data)
  ##{
  ##  print;
  ##  print "\n";
  ##}

  foreach $this_entry (@swver_data)
  {
    next if $this_entry !~ /^$dbmsout[$thishost]/;
    @words = split(/ /,$this_entry);
    $this_family = $words[1];
    $this_minver = $words[2];

    ##print "$titleraw[$thishost] $sw_version[$thishost] - Found this_family=$this_family this_minver=$this_minver\n";

    # Continue only if this is OUR family
    next if $sw_version[$thishost] !~ /^$this_family/;

    $z = length($this_minver);
    ##print "  z=$z \n";
    if (substr($sw_version[$thishost],0,$z) lt $this_minver)
    {
      &event("U",$thishost,"$dbmsout[$thishost] Version $sw_version[$thishost] is older than the minimum 'good' version ($this_minver) for this family ($this_family)","SWVER-OldVer","DBA652");
      last;
    }
  }

  # print "$P TLOG: $dbname $trunc $size $pctused $this_drive_letter $this_drive_pctused $dbp_log_fname $dbp_log_space\n";
  # dbamon_mssql.pl TLOG: master Yes 1.24 48.86 E 80.56 E:\\MSSQL7\\data\\mastlog.ldf Unlimited
  foreach (split('\n',$tlogdata[$thishost]))
  {
    @words = split;
    $tl_dbname   = $words[2]; 
    $tl_trunc    = $words[3]; 
    $tl_tlsize   = $words[4]; 
    $tl_pctused  = $words[5]; 
    $tl_drive    = $words[6]; 
    $tl_drivepct = $words[7]; 
    $tl_filename = $words[8]; 
    $tl_growth   = $words[9]; 

    #---- dbsize{} includes the tlog size - subtract out - tl_dbsize will be the size of the db only
    $tl_dbsize   = sprintf "%.2f",($dbsize{$tl_dbname}) - $tl_tlsize;
    $tl_ratio    = sprintf "%.2f",($tl_tlsize / $tl_dbsize) if $tl_dbsize > 0;

    $db_info_tl_trunc[$thishost]{$tl_dbname} = $tl_trunc; 

    $db_info_tl_dbsize[$thishost]{$tl_dbname} = $tl_dbsize; 
    $db_info_tl_tlsize[$thishost]{$tl_dbname} = $tl_tlsize; 
    $db_info_tl_ratio[$thishost]{$tl_dbname}  = $tl_ratio; 

    #---- Tlog RATIO hist row create
    &histCreate("sqlUp()",$thishost,"TLOG_RATIO",$tl_dbname,$tl_ratio,$tl_tlsize,$tl_dbsize);
    &metricsInsert("sqlUp()",$thishost,"TLOG_RATIO",$tl_dbname,$tl_ratio);

    #if ($tl_growth =~ /KB$/)
    #{
    #  $tl_growth = ...
    #}

    ## print "tl_dbname=$tl_dbname tl_trunc=$tl_trunc tl_tlsize=$tl_tlsize tl_pctused=$tl_pctused tl_drive=$tl_drive\n";
    ## print "  tl_ratio=$tl_ratio tl_drivepct=$tl_drivepct tl_filename=$tl_filename tl_growth=$tl_growth tl_dbsize=$tl_dbsize\n";
    ## print "$titleraw[$thishost] - tl_dbname=$tl_dbname tl_ratio=$tl_ratio tl_tlsize=$tl_tlsize tl_dbsize=$tl_dbsize\n";

    $tl_ratio_threshold = 5;

    &metricsCurrent("sqlUp()",$thishost,"TLOG_RATIO",$tl_dbname,$tl_ratio,'',$tl_ratio_threshold,"Size of TLOG Divided By Size of DB is $tl_ratio"); 

    if ($tl_ratio >= $tl_ratio_threshold && $tl_tlsize >= 1000)
    {
      open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
      print TMPFL2 "DBName:                $tl_dbname\n";
      print TMPFL2 "Trunc_Log_On_Ckpt:     $tl_trunc\n";
      print TMPFL2 "TLog_Pct_Full:         $tl_pctused\n";
      print TMPFL2 "TLog_Size:             $tl_tlsize (mB)\n";
      print TMPFL2 "DBSize:                $tl_dbsize (mB)\n";
      print TMPFL2 "TLogSize_DBSize_Ratio: $tl_ratio\n";
      print TMPFL2 "TLog_File_Path:        $tl_filename\n";
      print TMPFL2 "TLog_Drive:            $tl_drive\n";
      print TMPFL2 "TLog_Drive_Pct_Full:   $tl_drivepct\n";
      print TMPFL2 "TLog_Growth_Setting:   $tl_growth\n";
      close(TMPFL2);
      &event("C",$thishost,"DB=$tl_dbname - TLog is $tl_ratio times DB size and TLog is >= 1gB (DBSize=$tl_dbsize (mB) TLSize=$tl_tlsize (mB) Threshold=$tl_ratio_threshold)","TLog-Size-Ratio","DBA656",$tmpfl2);
    }
  }

  #---- If there aren't any user dbs, warning event 
  &metricsCurrent("sqlUp()",$thishost,"NON_SYSTEM_DB_COUNT","",$udbcount[$thishost],"",0,"Event if Zero"); 
  &event("U",$thishost,"Non-System DB Count is Zero","No-User-DBs","DBA663") if $udbcount[$thishost] ne "" && $udbcount[$thishost] == 0;

  #---- DBs with incorrect DB owner?
  if ($db_owner_counter > 0 && $g_sql_db_owner_event eq "Y")
  {
    #chop($date = `date +%Y/%m/%d-%H:%M:%S`);
    $date = &getdate; 
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "
-- =================================================================
--   SQL To Correct DB Names (Generated: $date):
-- =================================================================
";
    print TMPFL2 " \n";
    print TMPFL2 "-- Section A: SQL To CHANGE: \n";
    print TMPFL2 " \n";
    print TMPFL2 "$db_owner_fix";
    print TMPFL2 " \n";
    print TMPFL2 "-- Section B: SQL To ROLLBACK (Commented): \n";
    print TMPFL2 " \n";
    print TMPFL2 "$db_owner_rollback";
    close(TMPFL2);

    &event("U",$thishost,"DB Owner - Found $db_owner_counter DB(s) with Incorrect DB OWNER (Owner should be $db_good_owner)","DB-Owner=$db_owner_counter","DBA353",$tmpfl2);
  }

  #---- Log any needed metric history rows
  #($caller, $h, $c, $p, $v, $v2, $v3) = @_;
  &histCreate("sqlUp()",$thishost,"SERVER_MEM",".",$mem_pct[$thishost], $ram[$thishost], $mem_used[$thishost]) if $mem_pct[$thishost] && $ram[$thishost];
  &metricsInsert("sqlUp()",$thishost,"SERVER_MEM_PCT",".",$mem_pct[$thishost]);
  &metricsInsert("sqlUp()",$thishost,"SERVER_MEM_TOT",".",$ram[$thishost]);
  &metricsInsert("sqlUp()",$thishost,"SERVER_MEM_USED",".",$mem_used[$thishost]);

  &metricsCurrent("sqlUp()",$thishost,"SERVER_MEM_PCR","" ,$mem_pct[$thishost] ,"" ,"" ,"Percent of Server RAM In Use"); 

  &histCreate("sqlUp()",$thishost,"SERVER_CPU","BusyWithSQL", $cpu_busy_with_sql[$thishost]) if $cpu_busy_with_sql[$thishost] > 0;
  &metricsInsert("sqlUp()",$thishost,"S_CPU_BUSY_SQL",".",$cpu_busy_with_sql[$thishost]) if $cpu_busy_with_sql[$thishost] > 0;

  &metricsCurrent("sqlUp()",$thishost,"S_CPU_BUSY_SQL","" ,$cpu_busy_with_sql[$thishost] ,"" ,"" ,"Percent CPU Util. by SQL "); 

  #---- DoubleTke stuff
  if ($is_threshold[$thishost] > 0)
  {
    if ($doubletake_fileage_mins[$thishost]  == 999999)
    {
      &event("C",$thishost,"InSync: DoubleTake File $doubletake_file[$thishost] is MISSING","InSyncAge","DBA665",$tmpfl3);
    }
    elsif ($doubletake_fileage_mins[$thishost] > $is_threshold[$thishost])
    {
      &event("C",$thishost,"InSync: DoubleTake File Age: $doubletake_fileage_mins[$thishost] (Min.) exceeds threshold of $is_threshold[$thishost] (Min.)","InSyncAge","DBA665",$tmpfl3);
    }

    if ($doubletake_status[$thishost] !~ /Running/)
    {
      &event("C",$thishost,"InSync: DoubleTake Server is NOT Running (Status: $doubletake_status[$thishost]","InSyncDown","DBA665",$tmpfl3);
    }
  }

  #---- Userexit
  if (-x "/opt/dbamon/bin/userexit/inc_sqlup")
  {
    if (! $inc_userexit)
    {
      #---- Moved to main
      ##push(@INC,"/opt/dbamon/bin/userexit");
      $inc_userexit = 1;
    }
    require "inc_sqlup"; 
    &inc_sqlup;
  }
}
# -----------------------------------------------------------------------------
1;
